local OptionBoxes = {}
local barmin 
local barmax 
local buttons = {}
local orders = {"first", "second", "third", "fourth", "fifth", "sixth", "seventh", "eighth"}
local curDisplay = 1
local curModule = 1
local roster = {}
local classes = {}						
local icons = {}
local Percentage = {}
local dropdownitems = {} 
local curModule = 1
local timestamp = 1
local encountertable = {}
local nMember = 0						
local zoneID
local first = false
local nFight = 1
local encountername = "Puppe"
local loaded = false
local frameOffset = 0
local showFrame
local TimeLine = {}
local curFight = 1
local timelinebuttonscreated = false
local modulebuttonscreated = false
local xPosMF
local yPosMF
local startE
local endE
local modules = {"Percentage", "nofunction"}
local fsize = 12
local latest = "1.3"



if not SinnerFrame then
   CreateFrame("Frame", "SinnerFrame", UIParent)
end

function resetSV()

	TimeLineSV = {
		["first"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {" ", " ", " ", " "},
			["classes"] = {" ", " ", " ", " "},
			["icons"] = {" ", " ", " ", " "},
			["Percentage"] = {" ", " ", " ", " "},
		},
		["second"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {},
			["classes"] = {},
			["icons"] = {},
			["Percentage"] = {},
		},
		["third"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {},
			["classes"] = {},
			["icons"] = {},
			["Percentage"] = {},
		},	
		["fourth"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {},
			["classes"] = {},
			["icons"] = {},
			["Percentage"] = {},
		},	
		["fifth"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {},
			["classes"] = {},
			["icons"] = {},
			["Percentage"] = {},
		},
		["sixth"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {},
			["classes"] = {},
			["icons"] = {},
			["Percentage"] = {},
		},
		["seventh"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {},
			["classes"] = {},
			["icons"] = {},
			["Percentage"] = {},
		},
		["eighth"] = {
			["timestamp"] = 0,
			["encountername"] = "",
			["roster"] = {},
			["classes"] = {},
			["icons"] = {},
			["Percentage"] = {},
		},		
	}

	curDisplay = 1
	curModule = 1
	createContent(curDisplay, curModule)
end


local sinnerloadframe = CreateFrame("Frame", "sinnerloadframe", UIParent)

local SinnerMainFrame  = CreateFrame("Frame", "SinnerMainFrame", UIParent)
local SinnerRosterFrame = CreateFrame("ScrollingMessageFrame", nil, SinnerMainFrame)
local SinnerStatusFrame = CreateFrame("ScrollingMessageFrame", nil, SinnerMainFrame)
local SinnerModuleFrame = CreateFrame("ScrollingMessageFrame", nil, SinnerMainFrame)

local SinnerCloseButton = CreateFrame("Button", nil, SinnerMainFrame, "UIPanelButtonTemplate")
local SinnerOptionsButton = CreateFrame("Button", "SinnerOptionsButton", SinnerMainFrame, "UIPanelButtonTemplate")
local SinnerScrollBar = CreateFrame("Slider", nil, SinnerMainFrame, "UIPanelScrollBarTemplate")
local SinnerResizeButton = CreateFrame("Frame", nil, SinnerMainFrame)
local SinnerOptionsPanel = CreateFrame("Frame", "SinnerOptionsFrame", UIParent)


local SinnerTimeLineHeaderFrame = CreateFrame("Frame", "SinnerTimeLineHeaderFrame", SinnerMainFrame)
local SinnerTimeLineHeaderFrameButton = CreateFrame("Button", nil, SinnerMainFrame, "UIPanelButtonTemplate")
local TimeLineHeaderText = SinnerTimeLineHeaderFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
local SinnerTimeLineFrame = CreateFrame("Frame", nil, SinnerMainFrame)

local SinnerModuleHeaderFrame = CreateFrame("Frame", "SinnerModuleHeaderFrame", SinnerMainFrame)
local SinnerModuleHeaderFrameButton = CreateFrame("Button", nil, SinnerMainFrame, "UIPanelButtonTemplate")
local ModuleHeaderText = SinnerModuleHeaderFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
local SinnerPopModuleFrame = CreateFrame("Frame", nil, SinnerMainFrame)


sinnerloadframe:RegisterEvent("ADDON_LOADED")
SinnerFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
SinnerFrame:RegisterEvent("ENCOUNTER_START")
SinnerFrame:RegisterEvent("ENCOUNTER_END")
SinnerFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
SinnerFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
SinnerFrame:RegisterEvent("PLAYER_LEAVING_WORLD")



function updateFrames()
	SinnerMainFrame.width = SinnerMainFrame:GetWidth()
	SinnerMainFrame.height = SinnerMainFrame:GetHeight()
	SinnerStatusFrame:SetSize(fsize, math.floor(((SinnerMainFrame.height-20)/fsize))*fsize-1)
	SinnerRosterFrame:SetSize(0.5*SinnerMainFrame.width-fsize, math.floor(((SinnerMainFrame.height-20)/fsize))*fsize-1)
	SinnerRosterFrame:SetPoint("LEFT", fsize, 6)
	SinnerModuleFrame:SetSize(0.5*SinnerMainFrame.width, math.floor(((SinnerMainFrame.height-20)/fsize))*fsize-1)
	SinnerModuleHeaderFrame:SetWidth(0.5*SinnerMainFrame.width)
	SinnerTimeLineHeaderFrame:SetWidth(0.5*SinnerMainFrame.width)
	SinnerModuleHeaderFrameButton:SetWidth(0.5*SinnerMainFrame.width)
	SinnerTimeLineHeaderFrameButton:SetWidth(0.5*SinnerMainFrame.width)
	SinnerScrollBar:SetSize(30, SinnerMainFrame.height-20)
	
	
	barmin = math.floor(SinnerRosterFrame:GetHeight()/fsize)
	barmax = math.max(#TimeLineSV[orders[curDisplay]]["roster"]-1,1)
	if barmax > barmin then
		SinnerScrollBar:SetMinMaxValues(barmin, barmax)
		SinnerScrollBar:Show()
	else
	SinnerStatusFrame:SetScrollOffset(0)
	SinnerRosterFrame:SetScrollOffset(0)
	end
	
	--MouseWheel()
end


function OnMouseUp(self)
    SinnerMainFrame:StopMovingOrSizing()
	--SinnerStatusFrame:Show()
	--SinnerRosterFrame:Show()
	--SinnerModuleFrame:Show()
	--SinnerTimeLineHeaderFrame:Show()
	--SinnerModuleHeaderFrame:Show()
	updateFrames()
end

local OnMouseDown = function(self, button)
	if button == "LeftButton" then
		SinnerMainFrame:StartSizing()
		--SinnerScrollBar:Hide()
		--SinnerRosterFrame:Hide()
		--SinnerStatusFrame:Hide()
		--SinnerTimeLineHeaderFrame:Hide()
		--SinnerModuleHeaderFrame:Hide()
		--SinnerModuleFrame:Hide()
		
	end
end

function MouseWheel()

	SinnerMainFrame:SetScript("OnMouseWheel", function(self, delta)
		local cur_val = SinnerScrollBar:GetValue()
		local min_val, max_val = SinnerScrollBar:GetMinMaxValues()
		barmin = math.floor(SinnerRosterFrame:GetHeight()/fsize)
		barmax = math.max(#TimeLineSV[orders[curDisplay]]["roster"]-1,1)
		
		if barmin < barmax then
			
			if delta < 0 and cur_val < max_val then
				cur_val = math.min(max_val, cur_val + 1)
				SinnerScrollBar:SetValue(cur_val)
			elseif delta > 0 and cur_val > min_val then
				cur_val = math.max(min_val, cur_val - 1)
				SinnerScrollBar:SetValue(cur_val)
			end
		
		end
		
	end)

end


sinnerloadframe:SetScript("OnEvent", function(self, event, ...)
	
	
	
	if (not loaded) then
		loaded = true
		print("|cffFF0000Sinner |cffFFFFFF " .. latest .. " loaded - type \"/sinner help\" for options")		
		if (not SinnerSV) or (SinnerSV["version"] ~= latest) or (SinnerSV["version"] == nil) then
					
			SinnerSV = {
				["xPosMF"] = 0,
				["yPosMF"] = 0,
				["SVAnchor"] = "CENTER",
				["SVAnchorTo"] = "CENTER",
				["widthMF"] = 200,
				["heightMF"] = 250,
				["show"] = true,
				["lastDisplay"] = 1,
				["lastModule"] = 1,
				["version"] = latest
		
			}
			resetSV()
		end
		
		if not TimeLineSV then
			resetSV()
		end
		
		

		createSinnerFrame()
		createOptionsPanel()
		curDisplay = SinnerSV["lastDisplay"]
		curModule = SinnerSV["lastModule"]
		if SinnerSV["show"] then
			SinnerMainFrame:Show()
		end
		createContent(curDisplay, curModule)
	end
end)


function createSinnerFrame()

	 
	-- Main Frame
	
	SinnerMainFrame.width = SinnerSV["widthMF"]
	SinnerMainFrame.height = SinnerSV["heightMF"]
	SinnerMainFrame:SetFrameStrata("MEDIUM")
	SinnerMainFrame:SetSize(399,250)--SinnerMainFrame.width, SinnerMainFrame.height)
	SinnerMainFrame:ClearAllPoints()
	SinnerMainFrame:SetPoint(SinnerSV["SVAnchor"], UIParent, SinnerSV["SVAnchorTo"], SinnerSV["xPosMF"], SinnerSV["yPosMF"])
	SinnerMainFrame:SetBackdrop({
		bgFile   = "Interface\\DialogFrame\\UI-DialogBox-Background",
		--edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		tile     = true,
		tileSize = 32,
		edgeSize = 32,
		insets   = { left = 0, right = 0, top =0, bottom = 0}
	})
	SinnerMainFrame:SetBackdropColor(0, 0, 0, 1)
	SinnerMainFrame:EnableMouse(true)
	SinnerMainFrame:EnableMouseWheel(true)
	SinnerMainFrame:SetScript("OnSizeChanged", function (self)
		updateFrames()
		createContent(curDisplay, curModule)
	end)
	-- Make movable/resizable
	
	SinnerMainFrame:SetMovable(true)
	SinnerMainFrame:SetResizable(true)
	SinnerMainFrame:SetMinResize(160, 100)
	SinnerMainFrame:RegisterForDrag("LeftButton")
	SinnerMainFrame:SetScript("OnDragStart", SinnerMainFrame.StartMoving)
	SinnerMainFrame:SetScript("OnDragStop", SinnerMainFrame.StopMovingOrSizing)

	
	-- ScrollingMessageFrames

	SinnerRosterFrame:SetPoint("LEFT", fsize, 6)
	SinnerRosterFrame:SetSize(0.5*SinnerMainFrame.width-fsize, math.floor(((SinnerMainFrame.height-20)/fsize))*fsize-1)
	SinnerRosterFrame:SetFontObject(GameFontNormal)
	SinnerRosterFrame:SetTextColor(1, 1, 1, 1) -- default color
	SinnerRosterFrame:SetJustifyH("LEFT")
	SinnerRosterFrame:SetHyperlinksEnabled(true)
	SinnerRosterFrame:SetFading(false)
	SinnerRosterFrame:SetMaxLines(300)
	SinnerRosterFrame:SetResizable(true)
	SinnerRosterFrame:SetInsertMode("BOTTOM")
	SinnerMainFrame.SinnerRosterFrame = SinnerRosterFrame
	
	SinnerModuleFrame:SetPoint("Right", -10, 6)
	SinnerModuleFrame:SetSize(0.5*SinnerMainFrame.width-10, math.floor(((SinnerMainFrame.height-20)/fsize))*fsize-1)
	SinnerModuleFrame:SetFontObject(GameFontNormal)
	SinnerModuleFrame:SetTextColor(1, 1, 1, 1) -- default color
	SinnerModuleFrame:SetJustifyH("RIGHT")
	SinnerModuleFrame:SetHyperlinksEnabled(true)
	SinnerModuleFrame:SetFading(false)
	SinnerModuleFrame:SetMaxLines(300)
	SinnerModuleFrame:SetResizable(true)
	SinnerModuleFrame:SetInsertMode("BOTTOM")
	SinnerMainFrame.SinnerModuleFrame = SinnerModuleFrame
		
	SinnerStatusFrame:SetPoint("LEFT", 3, 6)
	SinnerStatusFrame:SetSize(fsize, math.floor(((SinnerMainFrame.height-20)/fsize))*fsize-1)
	SinnerStatusFrame:SetFontObject(GameFontNormal)
	SinnerStatusFrame:SetTextColor(1, 1, 1, 1) -- default color
	SinnerStatusFrame:SetJustifyH("LEFT")
	SinnerStatusFrame:SetHyperlinksEnabled(true)
	SinnerStatusFrame:SetFading(false)
	SinnerStatusFrame:SetMaxLines(300)
	SinnerStatusFrame:SetResizable(true)
	SinnerStatusFrame:SetInsertMode("BOTTOM")
	SinnerMainFrame.SinnerStatusFrame = SinnerStatusFrame

	
	-- Close Button

	SinnerCloseButton:SetPoint("BOTTOMLEFT", -3, -3)
	SinnerCloseButton:SetHeight(25)
	SinnerCloseButton:SetWidth(25)
	SinnerCloseButton:SetNormalTexture("Interface\\BUTTONS\\UI-StopButton")
	--SinnerCloseButton:SetPushedTexture("Interface\\BUTTONS\\UI-StopButton")
	--SinnerCloseButton:SetHighlightTexture("Interface\\CHATFRAME\\UI-ChatIM-SizeGrabber-Highlight")
	SinnerCloseButton:DisableDrawLayer("BACKGROUND")
	SinnerCloseButton:GetNormalTexture():SetTexCoord(1.5,-0.5,1.5,-0.5)
	SinnerCloseButton:SetScript("OnClick", function(self)
		HideParentPanel(self)
	end)
	SinnerMainFrame.SinnerCloseButton = SinnerCloseButton
	

	-- Resize Button
	
	SinnerResizeButton:SetPoint("BOTTOMRIGHT", 5, -5)
	SinnerResizeButton:SetHeight(25)
	SinnerResizeButton:SetWidth(25)
	--SinnerResizeButton:RegisterForDrag("LeftButton")
	--SinnerResizeButton:EnableMouse(true)
	--SinnerResizeButton:SetMovable(true)
	
	SinnerResizeButton:SetScript("OnMouseDown",OnMouseDown)
	SinnerResizeButton:SetScript("OnMouseUp",OnMouseUp)

	--SinnerResizeButton:DisableDrawLayer("BACKGROUND")
	SinnerResizeButtonBack = SinnerResizeButton:CreateTexture(nil, "BACKGROUND")
	SinnerResizeButtonBack:SetTexture("Interface\\CHATFRAME\\UI-ChatIM-SizeGrabber-Up")
	SinnerResizeButtonBack:SetAllPoints()
	--SinnerResizeButton:SetPushedTexture("Interface\\CHATFRAME\\UI-ChatIM-SizeGrabber-Down")
	--SinnerResizeButton:SetHighlightTexture("Interface\\CHATFRAME\\UI-ChatIM-SizeGrabber-Highlight")
	SinnerResizeButtonBack:SetTexCoord(-0.4,1.4,-0.4,1.4)
	--SinnerResizeButton:GetPushedTexture():SetTexCoord(1.5,0.5,1.5,0.5)
	--SinnerResizeButton:GetHighlightTexture():SetTexCoord(1.5,0.5,1.5,0.5)

	-- Options Button

	SinnerOptionsButton:SetPoint("BOTTOMLEFT", 10,-3)
	SinnerOptionsButton:DisableDrawLayer("BACKGROUND")
	SinnerOptionsButton:SetNormalTexture("Interface\\BUTTONS\\UI-OptionsButton")
	--SinnerOptionsButton:SetPushedTexture("Interface\\BUTTONS\\UI-OptionsButton")
	SinnerOptionsButton:GetNormalTexture():SetTexCoord(1.5,-0.5,1.5,-0.5)
	SinnerOptionsButton:GetHighlightTexture():SetTexCoord(1.5,-0.5,1.5,-0.5)
	SinnerOptionsButton:SetHighlightTexture("Interface\\CHATFRAME\\UI-ChatIM-SizeGrabber-Highlight")
	SinnerOptionsButton:SetHeight(25)
	SinnerOptionsButton:SetWidth(25)
	SinnerOptionsButton:SetScript("OnClick", function(self)
		InterfaceOptionsFrame_OpenToCategory(SinnerOptionsPanel) 
	end)
	SinnerMainFrame.SinnerOptionsButton = SinnerOptionsButton


	
	-- Scroll Bar
	
	SinnerScrollBar:SetPoint("RIGHT", SinnerMainFrame, "RIGHT", 24, 6)
	SinnerScrollBar:SetSize(30, SinnerMainFrame.height-20)
	local scrollmax = math.max(#TimeLineSV[orders[curDisplay]]["roster"]-1,1)
	local scrollmin = math.floor(SinnerRosterFrame:GetHeight()/fsize)
	
	if scrollmax < scrollmin then
		scrollmax = scrollmin + 1
	end
	
	SinnerScrollBar:SetMinMaxValues(scrollmin, scrollmax )
	SinnerScrollBar:SetValueStep(1)
	SinnerScrollBar:SetResizable(true)
	SinnerScrollBar.scrollStep = 5
	SinnerMainFrame.SinnerScrollBar = SinnerScrollBar
	local min_val, max_val = SinnerScrollBar:GetMinMaxValues()
	if min_val == max_val then
		SinnerScrollBar:Hide()
	end
	SinnerScrollBar:SetScript("OnMouseUp",OnMouseUp)
	SinnerScrollBar:SetScript("OnValueChanged", function(self, value)
		SinnerRosterFrame:SetScrollOffset(select(2, SinnerScrollBar:GetMinMaxValues()) - value)
		SinnerStatusFrame:SetScrollOffset(select(2, SinnerScrollBar:GetMinMaxValues()) - value)
		SinnerModuleFrame:SetScrollOffset(select(2, SinnerScrollBar:GetMinMaxValues()) - value)
		SinnerStatusFrame:Show()
		SinnerRosterFrame:Show()
		SinnerModuleFrame:Show()
		
		frameOffset = select(2, SinnerScrollBar:GetMinMaxValues()) - value
		
	end)

	SinnerScrollBar:SetValue(select(2, SinnerScrollBar:GetMinMaxValues()))

	
		
	-- Frames Regarding History/TimeLine function
	

	-- Frame that pops up when you click the TimeLine-Button
	SinnerTimeLineFrame.width = 300
	SinnerTimeLineFrame.height = 170
	SinnerTimeLineFrame:SetFrameStrata("MEDIUM")
	SinnerTimeLineFrame:SetSize(SinnerTimeLineFrame.width, SinnerTimeLineFrame.height)
	SinnerTimeLineFrame:ClearAllPoints()
	SinnerTimeLineFrame:SetPoint("TOP", 0, 190)
	SinnerTimeLineFrame:SetBackdrop({
		bgFile   = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile     = true,
		tileSize = 32,
		edgeSize = 16,
		insets   = { left = 2, right = 2, top = 2, bottom = 2 }
	})
	SinnerTimeLineFrame:SetScript("OnShow", function(self)
		local fadetime = 0
		createTimeLine()
		self:SetScript("OnUpdate", function(self, elapsed)
			fadetime = fadetime + elapsed 	
			if (fadetime > 8) then
				fadetime = 0
				SinnerTimeLineFrame:Hide()
			end
		end)
	end)
	SinnerTimeLineFrame:SetBackdropColor(0, 0, 0, 1)
	SinnerTimeLineFrame:Hide()
	
	
	-- Frame on the top left of the Main Frame
	local minutes = math.floor(TimeLineSV[orders[curDisplay]]["timestamp"]/60)
	local seconds = math.floor(TimeLineSV[orders[curDisplay]]["timestamp"] - minutes*60)
	SinnerTimeLineHeaderFrame:SetPoint("TOPLEFT", 0, fsize)
	SinnerTimeLineHeaderFrame:SetSize(0.5*SinnerMainFrame.width, fsize)
	SinnerTimeLineHeaderFrame:SetBackdrop({
		bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background",
		--edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile     = true,
		tileSize = 32,
		edgeSize = 16,
		insets   = { left = 0, right = 0, top = 0, bottom = 0}
	})
	SinnerTimeLineHeaderFrame:SetBackdropColor(0.4, 0.4, 0.4, 1)
	SinnerTimeLineHeaderFrame:SetResizable(true)
	TimeLineHeaderText:SetAllPoints(true)
	TimeLineHeaderText:SetTextColor(0,0,0,1)
	TimeLineHeaderText:SetJustifyH("LEFT")
	TimeLineHeaderText:SetJustifyV("TOP")
	TimeLineHeaderText:SetText("|cffFFFFFF" .. curDisplay .. ": " ..TimeLineSV[orders[curDisplay]]["encountername"] .. "(" .. minutes .. " m " .. seconds .. " s)")
		
	-- Button on top of the frame above // cliackability and highlightability
	SinnerTimeLineHeaderFrameButton:SetPoint("TOPLEFT", 0, fsize)
	SinnerTimeLineHeaderFrameButton:SetHeight(fsize)
	SinnerTimeLineHeaderFrameButton:SetWidth(0.5*SinnerMainFrame.width + 2)
	SinnerTimeLineHeaderFrameButton:DisableDrawLayer("BACKGROUND")
	SinnerTimeLineHeaderFrameButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
	SinnerTimeLineHeaderFrameButton:SetScript("OnClick", function(self)
		if SinnerTimeLineFrame:IsShown() then
			SinnerTimeLineFrame:Hide()
		else
			SinnerTimeLineFrame:Show()
		end
		
		if SinnerPopModuleFrame:IsShown() then
			SinnerPopModuleFrame:Hide()
		end
	end)
	SinnerMainFrame.SinnerTimeLineHeaderFrame = SinnerTimeLineHeaderFrame
	SinnerMainFrame.SinnerTimeLineHeaderFrameButton = SinnerTimeLineHeaderFrameButton

	
	
	-- Frames Regarding different modules
	

	-- Frame that pops up when you click the Module-Button
	SinnerPopModuleFrame.width = 300
	SinnerPopModuleFrame.height = 170
	SinnerPopModuleFrame:SetFrameStrata("MEDIUM")
	SinnerPopModuleFrame:SetSize(SinnerPopModuleFrame.width, SinnerPopModuleFrame.height)
	SinnerPopModuleFrame:ClearAllPoints()
	SinnerPopModuleFrame:SetPoint("TOP", 0, 190)
	SinnerPopModuleFrame:SetBackdrop({
		bgFile   = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile     = true,
		tileSize = 32,
		edgeSize = 16,
		insets   = { left = 2, right = 2, top = 2, bottom = 2 }
	})
	SinnerPopModuleFrame:SetScript("OnShow", function(self)
		local fadetime = 0
		createModules()
		self:SetScript("OnUpdate", function(self, elapsed)
			fadetime = fadetime + elapsed 	
			if (fadetime > 8) then
				fadetime = 0
				SinnerPopModuleFrame:Hide()
			end
		end)
	end)
	SinnerPopModuleFrame:SetBackdropColor(0, 0, 0, 1)
	SinnerPopModuleFrame:Hide()
	
	
	-- Frame on the top right of the Main Frame
	
	SinnerModuleHeaderFrame:SetPoint("TOPRIGHT", 0, fsize)
	SinnerModuleHeaderFrame:SetSize(0.5*SinnerMainFrame.width, fsize)
	SinnerModuleHeaderFrame:SetBackdrop({
		bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background",
		--edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile     = true,
		tileSize = 32,
		edgeSize = 16,
		insets   = { left = 0, right = 0, top = 0, bottom = 0 }
	})
	SinnerModuleHeaderFrame:SetBackdropColor(0.4, 0.4, 0.4, 1)
	SinnerModuleHeaderFrame:SetResizable(true)
	ModuleHeaderText:SetAllPoints(true)
	ModuleHeaderText:SetTextColor(1,1,1,1)
	ModuleHeaderText:SetJustifyH("Center")
	ModuleHeaderText:SetJustifyV("TOP")
	ModuleHeaderText:SetText(modules[curModule])
		
	-- Button on top of the frame above // cliackability and highlightability
	SinnerModuleHeaderFrameButton:SetPoint("TOPRIGHT", 0, fsize)
	SinnerModuleHeaderFrameButton:SetHeight(fsize)
	SinnerModuleHeaderFrameButton:SetWidth(0.5*SinnerMainFrame.width)
	SinnerModuleHeaderFrameButton:DisableDrawLayer("BACKGROUND")
	SinnerModuleHeaderFrameButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
	SinnerModuleHeaderFrameButton:SetScript("OnClick", function(self)
		if SinnerPopModuleFrame:IsShown() then
			SinnerPopModuleFrame:Hide()
		else
			SinnerPopModuleFrame:Show()
		end
		
		if SinnerTimeLineFrame:IsShown() then
			SinnerTimeLineFrame:Hide()
		end
		
	end)
	SinnerMainFrame.SinnerModuleHeaderFrame = SinnerModuleHeaderFrame
	SinnerMainFrame.SinnerModuleHeaderFrameButton = SinnerModuleHeaderFrameButton
	

	MouseWheel()
end
	
function createOptionsPanel()
	--Interface/Addons Panel
	
	
	
	SinnerOptionsPanel.name = "Sinner"
	InterfaceOptions_AddCategory(SinnerOptionsPanel)
	local CheckLabels = {"Dungeons", "Emerald Nightmare", "Trials of Valor", "Nighthold", "Tomb of Sargeras"}
	for i=1, 10, 1 do
		OptionBoxes[i] = CreateFrame("CheckButton", "DungeonsCheckBox", SinnerOptionsPanel, "UICheckButtonTemplate")
		
		OptionBoxes[i]:SetText(CheckLabels[i])
		OptionBoxes[i]:SetPoint("TOPLEFT", 30, -30*i)
	
	end

end



function createTimeLine()

	if not timelinebuttonscreated then
		timelinebuttonscreated = true
		for i = 1, #orders, 1 do
		
			buttons[i] = CreateFrame("Button", nil, SinnerTimeLineFrame, "UIPanelButtonTemplate")
			buttons[i]:DisableDrawLayer("BACKGROUND")
			buttons[i]:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
			buttons[i]:GetHighlightTexture():SetTexCoord(0,1,0,1)
			buttons[i]:SetHeight(15)
			buttons[i]:SetWidth(250)
			buttons[i]:SetPoint("TOP", 0, -18*(i-1)-15)
			
			buttons[i]:SetScript("OnClick", function(self)
				createContent(i, curModule)
				SinnerTimeLineFrame:Hide()
				curDisplay = i
				
			end)
			
		end
	end
	
	for i = 1, #orders, 1 do
		if TimeLineSV[orders[i]]["timestamp"] then
			local minutes = math.floor(TimeLineSV[orders[i]]["timestamp"]/60)
			local seconds = math.floor(TimeLineSV[orders[i]]["timestamp"] - minutes*60)
			buttons[i]:SetText("|cffFFFFFF" .. i .. ": " .. TimeLineSV[orders[i]]["encountername"] .. "(" .. minutes .. "m " .. seconds .. "s)")
		else
			buttons[i]:SetText("|cffFFFFFF" .. i .. ": " .. TimeLineSV[orders[i]]["encountername"])
		end
	end
	
end

function createModules()

	if not modulebuttonscreated then
		modulebuttonscreated = true
		for i = 1, #modules, 1 do
		
			buttons[i] = CreateFrame("Button", nil, SinnerPopModuleFrame, "UIPanelButtonTemplate")
			buttons[i]:DisableDrawLayer("BACKGROUND")
			buttons[i]:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
			buttons[i]:GetHighlightTexture():SetTexCoord(0,1,0,1)
			buttons[i]:SetHeight(15)
			buttons[i]:SetWidth(250)
			buttons[i]:SetPoint("TOP", 0, -18*(i-1)-15)
			buttons[i]:SetText("|cffFFFFFF" .. modules[i])
			
			buttons[i]:SetScript("OnClick", function(self)
				createContent(curDisplay, i)
				SinnerPopModuleFrame:Hide()
				curModule = i
				
			end)
			
		end
	end
		
end

function createContent(curDisplay, curModule)
	
	local order = orders[curDisplay]
	local mode = modules[curModule]
	
	if SinnerRosterFrame:GetNumMessages() > 0 then
		SinnerStatusFrame:Clear()
		SinnerRosterFrame:Clear()
		SinnerModuleFrame:Clear()
	end
		
	for i = 1, #TimeLineSV[order]["roster"], 1 do
			
		SinnerRosterFrame:AddMessage(TimeLineSV[order]["classes"][i] .. TimeLineSV[order]["roster"][i])
		SinnerStatusFrame:AddMessage(TimeLineSV[order]["icons"][i])
		SinnerModuleFrame:AddMessage(TimeLineSV[order][mode][i])
			
	end
	
	if TimeLineSV[orders[curDisplay]]["timestamp"] then
		local minutes = math.floor(TimeLineSV[orders[curDisplay]]["timestamp"]/60)
		local seconds = math.floor(TimeLineSV[orders[curDisplay]]["timestamp"] - minutes*60)
		TimeLineHeaderText:SetText("|cffFFFFFF" .. curDisplay .. ": " .. TimeLineSV[orders[curDisplay]]["encountername"] .. "(" .. minutes .. " m " .. seconds .. " s)")
	else
		TimeLineHeaderText:SetText("|cffFFFFFF" .. curDisplay .. ": " .. TimeLineSV[orders[curDisplay]]["encountername"])
	end
	ModuleHeaderText:SetText(modules[curModule])
	
	local barmin = math.floor(SinnerRosterFrame:GetHeight()/fsize)
	local barmax = math.max(#TimeLineSV[orders[curDisplay]]["roster"]-1,1)
			
	if barmax > barmin then
		SinnerScrollBar:SetMinMaxValues(barmin, barmax)
		SinnerScrollBar:Show()
		SinnerStatusFrame:SetScrollOffset(frameOffset)
		SinnerRosterFrame:SetScrollOffset(frameOffset)
		SinnerModuleFrame:SetScrollOffset(frameOffset)
		
	else
		
		SinnerStatusFrame:SetScrollOffset(0)
		SinnerRosterFrame:SetScrollOffset(0)
		SinnerModuleFrame:SetScrollOffset(0)
		
	end
	
	
end


	

function realmsplit(inputstr, sep) -- Deletes the "-Realm"-Part in "Name-Realm" // e.g. "Shogio-Gul'dan" -> "Shogio"
	if sep == nil then
		sep = "-"
	end
	if inputstr ~= nil then
		local t={} ; i=1
		for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
			t[i] = str
			i = i + 1
		end
		return t[1]
	end
end

function concatnames(inputarray)

	local t = { }
	for k,v in ipairs(inputarray) do
		t[#t+1] = tostring(v)
	end
	return table.concat(t," ")

end

function removedup(inputarray)

	local outputarray = {}
	local i = 1
	local j = 1
	local nEntries = #inputarray
	local duplicate = false
	local checkentry
	local nOut = 1
	
	while i <= nEntries do
	checkentry = inputarray[i]
	
		while j <= nEntries do
		
			if i ~= j then
				if inputarray[i] == inputarray[j] then
					duplicate = true
					
				end
			end
			j=j+1
		end
		
		if not duplicate then
			
			outputarray[nOut] = checkentry
			nOut = nOut +1
		end
		j=i+1
		i=i+1
		duplicate = false
	end
	
	return outputarray

end

function classcolor(class)
	if class == "Death Knight" then
		return "|cffC41F3B"
	elseif class == "Demon Hunter" then
		return "|cffA330C9"
	elseif class == "Druid" then
		return "|cffFF7D0A"
	elseif class == "Hunter" then
		return "|cffABD473"
	elseif class == "Mage" then
		return "|cff69CCF0"
	elseif class == "Monk" then
		return "|cff00FF96"
	elseif class == "Paladin" then
		return "|cffF58CBA"
	elseif class == "Priest" then
		return "|cffFFFFFF"
	elseif class == "Rogue" then
		return "|cffFFF569"
	elseif class == "Shaman" then
		return "|cff0070DE"
	elseif class == "Warlock" then
		return "|cff9482C9"
	elseif class == "Warrior" then
		return "|cffC79C6E"
	else
		return "Class Unknown "
	end
		
end


 



SinnerFrame:SetScript("OnEvent", function(self, event, ...)
	
	zoneID = GetCurrentMapAreaID()
	if(zoneID == 1052 or zoneID == 1094 or zoneID == 1114 or zoneID == 1088 or zoneID == 1147) then
		if event == "ENCOUNTER_START" then
		--if event == "PLAYER_REGEN_DISABLED" then
			nMember = GetNumGroupMembers()
			startE = GetTime()
			
			for i = 7, 1, -1 do
					
				TimeLineSV[orders[i+1]]["roster"] = TimeLineSV[orders[i]]["roster"]
				TimeLineSV[orders[i+1]]["classes"] = TimeLineSV[orders[i]]["classes"]
				TimeLineSV[orders[i+1]]["icons"] = TimeLineSV[orders[i]]["icons"]
				TimeLineSV[orders[i+1]]["encountername"] = TimeLineSV[orders[i]]["encountername"]
				TimeLineSV[orders[i+1]]["timestamp"] = TimeLineSV[orders[i]]["timestamp"]
				TimeLineSV[orders[i+1]]["Percentage"] = TimeLineSV[orders[i]]["Percentage"]
			end
				
			if curDisplay == 1 then
				curDisplay = 1
			elseif curDisplay < 7 then
				curDisplay = curDisplay + 1
			else
				curDisplay = 7
			end
			createContent(curDisplay, curModule)
			encountername = select(2, ...) 
			roster = {}
			icons = {}
			classes = {}
			Percentage = {}
				
			for i = 1, nMember, 1 do
				local name, rank, grp, lvl, class, filename, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
				roster[i] = realmsplit(name)
				icons[i] = " "
				classes[i] = classcolor(class)
				Percentage[i] = " "
								
			end
			
			TimeLineSV[orders[1]]["roster"] = roster
			TimeLineSV[orders[1]]["icons"] = icons
			TimeLineSV[orders[1]]["classes"] = classes
			TimeLineSV[orders[1]]["encountername"] = encountername
			TimeLineSV[orders[1]]["timestamp"] = nil
			TimeLineSV[orders[1]]["Percentage"] = Percentage
			
			
			if curDisplay == 1 then
				createContent(curDisplay, curModule)
			end
			
		end
		

		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			
			local CombatEvent = select(2, ...)
			local SpellName = select(13, ...) 
			local TSourceName = select(5, ...)
			local SourceName = realmsplit(TSourceName)
			local SpellID = select(12, ...)
				
			if CombatEvent == "SPELL_HEAL" then
				local health = UnitHealth(TSourceName)
				local healthmax = UnitHealthMax(TSourceName)
				local percentage = tostring(math.floor(100*(health/healthmax))) .. "\% "
				if (SpellID == 6262) then -- HealthStone 6262 // 185123
				
					
					for i = 1, nMember, 1 do
					
						if roster[i] == SourceName then
							TimeLineSV[orders[1]]["icons"][i] = "|TInterface\\ICONS\\Warlock_ Healthstone:8|t"
							TimeLineSV[orders[1]]["Percentage"][i] = percentage
							
						end
					end
					
					if curDisplay == 1 then
						createContent(curDisplay, curModule)
					end
					
					
				end
			
				if (SpellID == 188016) then -- Ancient Healing Pot 188016 // 213243
					
					for i = 1, nMember, 1 do
					
						if roster[i] == SourceName then
							TimeLineSV[orders[1]]["icons"][i] = "|TInterface\\ICONS\\INV_Potion_49:8|t"
							TimeLineSV[orders[1]]["Percentage"][i] = percentage
							
						end
					end
					
					if curDisplay == 1 then
						createContent(curDisplay, curModule)
					end
					
				end
			end
			
		end
		
		if event == "ENCOUNTER_END" then
		
			TimeLineSV[orders[1]]["timestamp"] = GetTime() - startE
			
			createContent(curDisplay, curModule)
			
			
			nMember = 0
				
		end
	end

	if event == "PLAYER_LEAVING_WORLD" then
				
		if SinnerMainFrame:IsShown() then
			showFrame = true
		else
			showFrame = false
		end
		local SVAnchor, relativeTo, SVAnchorTo, xPosMF, yPosMF = SinnerMainFrame:GetPoint(1)
		SinnerSV = {["xPosMF"] = xPosMF, 
			["yPosMF"] = yPosMF,
			["SVAnchor"] = SVAnchor,
			["SVAnchorTo"]  = SVAnchorTo,
			["widthMF"] = SinnerMainFrame.width, 
			["heightMF"] = SinnerMainFrame.height,
			["show"] = showFrame,
			["lastDisplay"] = curDisplay,
			["lastModule"] = curModule,
			["version"] = latest,
		}
	end
	
end)

SLASH_SINNER1 = "/sinner"
SlashCmdList.SINNER = function(arg)
	if arg == "toggle" or arg == "show" or arg == "hide" or arg =="" then
		if SinnerMainFrame:IsShown() then
			SinnerMainFrame:Hide()
		else
			SinnerMainFrame:Show()
		end
		
	elseif arg == "help" then
		print("|cffFF0000Sinner|cffFFFFFF toggle: Shows/Hides the main frame.")
		print("|cffFF0000Sinner|cffFFFFFF reset: Resets History.")
		
	elseif arg == "reset" then
		resetSV()	
	else
		print("|cffFF0000Sinner|cffFFFFFF ".. arg .. ": command unknown - type '/sinner help' for available options ")
		
	end
end
 